import { MidwayConfig } from '@midwayjs/core';

export default {
  // use for cookie sign key, should change to your own and keep security
  keys: '1706233305258_2242',
  koa: {
    port: 7001,
  },
  // 请求记录在redis留存时间,超过时间.数据变化将不会记录.以秒为单位--5分钟
  requestTimeLimit: 300,
  jwt: {
    secret: 'Ziyouyanfa!@#',
    expiresIn: 3600, // 3600
  },
  i18n: {
    defaultLocale: 'zh-cn',
    fallbacks: {
      'en*': 'en_us',
      'zh*': 'zh-cn',
    },
    localeTable: {
      en_us: {
        default: require('../locales/en_us/defaults'),
        error: require('../locales/en_us/errors'),
      },
      zh_cn: {
        default: require('../locales/zh_cn/defaults'),
        error: require('../locales/zh_cn/errors'),
        methods: require('../locales/zh_cn/controller_method'),
      },
    },
  },
  validate: {
    validationOptions: {
      allowUnknown: true, // 全局生效
    },
  },
  webSocket: {
    serverHeartbeatInterval: 30000,
    enableServerHeartbeatCheck: true,
  },
} as MidwayConfig;
