import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'achievement' },
})
export class Achievement extends BaseModel {
  @prop({ required: false, index: true, zh: '平台用户id' })
  user: string;
  @prop({ required: false, index: true, zh: '专利号' })
  patent: string;
  @prop({ required: false, index: true, zh: '名称' })
  name: string;
  @prop({ required: false, index: true, zh: '属性' })
  attribute: string;
  @prop({ required: false, index: true, zh: '出让方式' })
  sell: string;
  @prop({ required: false, index: true, zh: '成熟度' })
  mature: string;
  @prop({ required: false, index: true, zh: '行业领域' })
  field: string;
  @prop({ required: false, index: true, zh: '技术分类' })
  technology: string;
  @prop({ required: false, index: true, zh: '成果地区' })
  area: Array<any>;
  @prop({ required: false, index: false, zh: '发布时间' })
  time: string;
  @prop({ required: false, index: true, zh: '参考价格' })
  money: string;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: false, zh: '附件' })
  file: Array<any>;
  @prop({ required: false, index: true, zh: '成果状态', default: '0' })
  achievement_status: string;
  @prop({ required: false, index: true, zh: '是否公开', default: '1' })
  is_use: string;
  @prop({ required: false, index: true, zh: '状态' , default: '0'})
  status: string;
}
