import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'demand' },
})
export class Demand extends BaseModel {
  @prop({ required: false, index: true, zh: '平台用户id' })
  user: string;
  @prop({ required: false, index: true, zh: '名称' })
  name: string;
  @prop({ required: false, index: true, zh: '类型' })
  type: string;
  @prop({ required: false, index: true, zh: '行业领域' })
  field: string;
  @prop({ required: false, index: false, zh: '需求紧急度' })
  urgent: string;
  @prop({ required: false, index: true, zh: '合作方式' })
  method: string;
  @prop({ required: false, index: false, zh: '有效期' })
  time: Array<any>;
  @prop({ required: false, index: false, zh: '价格' })
  money: string;
  @prop({ required: false, index: true, zh: '需求地区' })
  area: Array<any>;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: true, zh: '需求状态', default: '0' })
  demand_status: string;
  @prop({ required: false, index: true, zh: '是否公开', default: '1' })
  is_use: string;
  @prop({ required: false, index: true, zh: '状态' })
  status: string;
}
