import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'match' },
})
export class Match extends BaseModel {
  @prop({ required: false, index: true, zh: '平台用户id' })
  user: string;
  @prop({ required: false, index: true, zh: '名称' })
  name: string;
  @prop({ required: false, index: true, zh: '类型' })
  type: string;
  @prop({ required: false, index: true, zh: '组织单位' })
  work: string;
  @prop({ required: false, index: true, zh: '行业' })
  industry: string;
  @prop({ required: false, index: true, zh: '类别' })
  form: string;
  @prop({ required: false, index: false, zh: '有效期' })
  time: Array<any>;
  @prop({ required: false, index: false, zh: '奖金' })
  money: string;
  @prop({ required: false, index: false, zh: '赛事规则', default: {} })
  rules: object;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: false, zh: '封面' })
  file: Array<any>;
  @prop({ required: false, index: true, zh: '赛事状态', default: '0' })
  match_status: string;
  @prop({ required: false, index: true, zh: '是否公开', default: '1' })
  is_use: string;
  @prop({ required: false, index: true, zh: '状态', default: '0' })
  status: string;
}
