import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'news' },
})
export class News extends BaseModel {
  @prop({ required: false, index: true, zh: '标题' })
  title: string;
  @prop({ required: false, index: true, zh: '封面' })
  logo: Array<any>;
  @prop({ required: false, index: false, zh: '发布人' })
  person: string;
  @prop({ required: false, index: false, zh: '发布时间' })
  time: string;
  @prop({ required: false, index: false, zh: '内容' })
  content: string;
  @prop({ required: false, index: false, zh: '浏览次数', default: 0 })
  number: number;
  @prop({ required: false, index: false, zh: '类型', remark: '0:政策新闻,1:新闻资讯', default: '0' })
  type: string;
  @prop({ required: false, index: true, zh: '是否使用', default: '1' })
  is_use: string;
  @prop({ required: false, index: true, zh: '状态' , default: '0'})
  status: string;
}
