import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'company' },
})
export class Company extends BaseModel {
  @prop({ required: false, index: true, zh: '平台用户id' })
  user: string;
  @prop({ required: false, index: true, zh: '企业名称' })
  name: string;
  @prop({ required: false, index: false, zh: 'logo' })
  logo: Array<any>;
  @prop({ required: false, index: false, zh: '统一信用代码' })
  code: string;
  @prop({ required: false, index: false, zh: '企业类型' })
  pattern: string;
  @prop({ required: false, index: false, zh: '企业规模' })
  scale: string;
  @prop({ required: false, index: true, zh: '联系电话' })
  phone: string;
  @prop({ required: false, index: true, zh: '所属行业' })
  type: string;
  @prop({ required: false, index: true, zh: '所在地区' })
  area: Array<any>;
  @prop({ required: false, index: false, zh: '法定代表人' })
  representative: string;
  @prop({ required: false, index: false, zh: '电子邮箱' })
  email: string;
  @prop({ required: false, index: true, zh: '员工人数' })
  person: number;
  @prop({ required: false, index: false, zh: '注册资本' })
  register: string;
  @prop({ required: false, index: false, zh: '成立日期' })
  create_time: string;
  @prop({ required: false, index: false, zh: '地址' })
  address: string;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: true, zh: '是否公开' })
  is_show: string;
  @prop({ required: false, index: true, zh: '公司状态', default: '0' })
  companyStatus: string;
  @prop({ required: false, index: true, zh: '状态', default: '0' })
  status: string;
}
