import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'expert' },
})
export class Expert extends BaseModel {
  @prop({ required: false, index: true, zh: '平台用户id' })
  user: string;
  @prop({ required: false, index: true, zh: '专家姓名' })
  name: string;
  @prop({ required: false, index: false, zh: '头像' })
  icon: Array<any>;
  @prop({ required: false, index: true, zh: '性别' })
  gender: string;
  @prop({ required: false, index: false, zh: '出生年月' })
  birth: string;
  @prop({ required: false, index: false, zh: '证件类型' })
  cardType: string;
  @prop({ required: false, index: false, zh: '证件号码' })
  card: string;
  @prop({ required: false, index: true, zh: '联系电话' })
  phone: string;
  @prop({ required: false, index: true, zh: '所属领域' })
  field: string;
  @prop({ required: false, index: true, zh: '研究方向' })
  direction: string;
  @prop({ required: false, index: true, zh: '工作单位' })
  work: string;
  @prop({ required: false, index: true, zh: '学历' })
  education: string;
  @prop({ required: false, index: true, zh: '职称' })
  title: string;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: true, zh: '所在地区' })
  area: Array<any>;
  @prop({ required: false, index: true, zh: '是否公开' })
  is_show: string;
  @prop({ required: false, index: true, zh: '状态', default: '0' })
  status: string;
}
