const codes = {
  '-1': 'unknown error',
  '-2': 'need params',
  '-20': 'params error',
  '-3': 'need query',
  '-30': 'query error',
  '-4': 'need body',
  '-40': 'body error',
  '-5': 'need args',
  '-50': 'bad args',
  '-10': 'data not found',
  '-100': 'service fault',
  '-500': 'request falut',
  '-3000': 'ElasticSearch error',
  '-3001': 'ElasticSearch error, index not found',
  '400': 'Service encountered an error',
  '400-1': 'Function temporarily unavailable',
  '401': 'You do not have permission for the current function!',
  '401-1': 'User not found',
  '401-2': 'Password error',
  '401-3': 'No login information detected, please log in again!',
  '401-4': 'Account login has expired, please log in again!',
  '401-5': 'This account has been logged in elsewhere, please log in again!',
  '401-6': 'The user has been disabled',
  '401-7': 'Users in the current role are unable to use',
};
const errCodes = {};
const prefix = 'FRAMEERROR_';
for (const key in codes) {
  errCodes[`${prefix}${key}`] = codes[key];
}
export default {
  test: 'error language is: {locale}',
  ...errCodes,
};
