import { IMiddleware } from '@midwayjs/core';
import { Middleware } from '@midwayjs/decorator';
import { NextFunction, Context } from '@midwayjs/koa';
@Middleware()
export class newsQueryMiddleware implements IMiddleware<Context, NextFunction> {
  resolve() {
    return async (ctx: Context, next: NextFunction) => {
      // 获取原始的查询参数对象
      const rawQuery = ctx.request.query;
      // 创建一个空对象来存储处理后的查询参数
      const parsedQuery = {};
      // 遍历原始的查询参数
      for (const key in rawQuery) {
        // 检查键是否以 [] 结尾
        if (key.endsWith('[]')) {
          // 去除 [] 后缀，并将值存储到数组中
          const paramName = key.slice(0, -2);
          if (!Array.isArray(parsedQuery[paramName])) {
            parsedQuery[paramName] = [];
          }
          parsedQuery[paramName] = rawQuery[key];
        } else {
          // 非数组参数直接存储
          parsedQuery[key] = rawQuery[key];
        }
      }
      ctx.filter = parsedQuery;
      await next();
    };
  }
}
