import { Config, Inject, Provide } from '@midwayjs/decorator';
import { MidwayI18nService } from '@midwayjs/i18n';
import { Context } from '@midwayjs/koa';

@Provide()
export class I18nService {
  @Config('i18n.defaultLocale')
  defaultLocale: string;
  @Inject()
  ctx: Context;
  @Inject()
  i18n: MidwayI18nService;

  translate(code:any) {
    return this.i18n.translate(`${code}`, { locale: this.ctx.locale });
  }
  translateError(code:any) {
    return this.i18n.translate(`${code}`, { locale: this.ctx.locale, group: 'error' });
  }
  translateMethod(code:any) {
    return this.i18n.translate(`${code}`, { locale: this.ctx.locale, group: 'error' });
  }
}
