import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService } from 'free-midway-component';
import { Match } from '../../entity/platform/match.entity';
import { get } from 'lodash';
import { Collection } from '../../entity/platform/collection.entity';
type modelType = ReturnModelType<typeof Match>;
@Provide()
export class MatchService extends BaseService<modelType> {
  @InjectEntityModel(Match)
  model: modelType;

  @InjectEntityModel(Collection)
  cModel: ReturnModelType<typeof Collection>;

  // 比赛详情
  async detail(id) {
    const user = this.ctx.user;
    const data = { userInfo: {}, is_collection: false };
    const arr = await this.model.findById(id).lean();
    if (arr && get(arr, '_id')) {
      // 查询是否收藏该比赛
      if (user && user._id) {
        const collection = await this.cModel.findOne({ user: user._id, source: arr._id }).lean();
        if (collection) data.is_collection = true;
      }
    }
    return { ...arr, ...data };
  }
}
