import { Provide } from '@midwayjs/decorator';
import { GetModel } from 'free-midway-component';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { upperFirst } from 'lodash';
import { User } from '../entity/system/user.entity';
@Provide()
export class UtilService {
  @InjectEntityModel(User)
  uModel: ReturnModelType<typeof User>;

  randomStr(len = 6) {
    return Math.random().toString(36).slice(-len);
  }

  // 修改后信息后用户重新审核
  async updateUserAfter(id, body, role_type) {
    const { status } = body;
    if (status === '0') {
      const model = GetModel(upperFirst(role_type));
      const data = await model.findById(id).lean();
      await this.uModel.updateOne({ _id: data.user }, { status: '0' });
    }
  }
}
